// Main.c - Main Code For Savage Afterburner Balls Demo
// ----------------------------------------------------
// Copyright (C)Savage Development.
// By Matthew Tighe
//
// Please don't criticise this code, I know it is SLOW.
// Its just to illustrate what I'm talking about.
//
// Its taken a long time coz I've had to figure out how
// to get the compiler to work with malloc.....
// It does with my linker script.... Check out the makefile.

#include "gba.h"
#include "savage.h"
//#include "fixmath.h"
#include "gfx\font.h"
#include "gfx\ball.h"			// Demo sprite data
#include "gfx\logo.h"
#include "gfx\objects.h"

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include "sintables.h"

typedef double MATRIX[4][4];		// Matrix of doubles's
typedef double VECTOR[3];		// Vector of doubles's

// Screen Handling Functions
// -------------------------
void scrWaitVbl();
void scrWaitVSync();
u16 scrIsVbl();
u16 padRead();
u16 padReadDiff();
u16 padWaitChange();
void palCopy( u16 *pPal, int nStart, const u16 *pColours, int nCount );

// Our demo's functions
// -------------------------

void sprPoint(GFXSPRITE *pSprite, VECTOR v, WORD size);
void MakeGrid();		// Makes the sprite grid.
void render(GFXLIST *pList, const VECTOR *vectors, const WORD *names, u32 uNumber );

void matIdentity( MATRIX m );
void matTransform( VECTOR v, MATRIX m);
void matMult( MATRIX d, MATRIX m );
void matRotateX( double theta, MATRIX m );
void matRotateY( double theta, MATRIX m );
void matRotateZ( double theta, MATRIX m );

// The objects
// ------------------------

VECTOR grid[25] = { { 0,0,0 }, { 0,0,0 } };

VECTOR view;

MATRIX rot;

FONT fntSystem;					// Make system and text writing stuff global ( for debugging text)
u16 *pText;
u8 *pFont;
u16 pad;
char szText[128];

int AgbMain()
{
	GFXLIST gfxList;
	GFXSPRITE *pTemp;
	u8 *pObjTiles, *pTiles;
	u16 *pMap;
	int nSelection,i;
	double dRotX, dRotZ, dRotY;

	pObjTiles = (u8*)0x6010000;

	DISPCNT = DISP_MODE(0) | DISP_OBJ | DISP_BG0 | DISP_BG1 | DISP_OAMSEQ;				// Set Mode 0, objs on

	BG0CNT = BG_CHARBASE(0x4000) | BG_COLOUR_256x1 | BG_T256x256;			// BG 0 Characters at 0x4000
	BG0X = 0;
	BG0Y = 0;
	pText = (u16*)0x6000000;
	pFont = (u8*)0x6004000;

	BG1CNT = BG_CHARBASE(0x8000) | BG_MAPBASE(0x800) | BG_COLOUR_256x1 | BG_T256x256;			// BG 1 Characters at 0x4000
	BG1X = 0;
	BG1Y = 0;
	pMap = (u16*)0x6000800;
	pTiles = (u8*)0x6008000;


	// Copy the tile data into VRAM
	memcpy( pFont, fontBlk, fontBlkHeader.ddLength);			// Font
	memcpy( pTiles, savageBlk, savageBlkHeader.ddLength );		// Background
	memcpy( pObjTiles, ballBlk, ballBlkHeader.ddLength);		// Ball sprites
	
	mapPut( 0, 2, 30,16, pMap, savageMap, 0);

	// Load the video characters and palettes
	palCopy( (u16 *) OBJ_PAL, 0, ballPal, ballPalHeader.dwColours );
	palCopy( (u16 *) BG_PAL, 0, savagePal, savagePalHeader.dwColours );


	// Set up font descriptor

	fntSystem.dwStart = 1;
	fntSystem.dwAdjust = -32;
	fntSystem.dwHeight = 1;
	fntSystem.dwWidth = 1;

	// Create empty object list
	sprInit( &gfxList );

	// Initialise the sprites 5x5 grid
//	MakeGrid();

	// Set up viewing vector;

	view[0] = 0.0;
	view[1] = 0.0;
	view[2] = 64.0;

	for(i = 0; i < 25; i++)
		{
			pTemp = sprCreate( &gfxList );
			pTemp->size = SPR_16x16;
			pTemp->tile = 0;
		}

	nSelection = 0;
	dRotX = 0.0;
	dRotY = 0.0;
	dRotZ = 0.0;

	mapPrint( 1, 1, pText, " 3D Balls Demo (21/06/2001)", &fntSystem);
	mapPrint( 1, 2, pText, "----------------------------", &fntSystem);
	mapPrint( 1, 3, pText, "      By Matthew Tighe", &fntSystem);
	mapPrint( 1, 4, pText, "   www.matt-tighe.co.uk/gba", &fntSystem);
	mapPrint( 1, 8, pText, "Just a short demo similar to", &fntSystem);
	mapPrint( 1, 9, pText, "  the Afterburner II intro.", &fntSystem);
	mapPrint( 1, 15, pText," Use Pad and L/R to rotate.", &fntSystem);

	mapPrint( 0, 18, pText, "         Press Start", &fntSystem);

	do
	{
		pad = padRead();

	} while( pad & PAD_START );
	
	// Clear the text
	mapSet( 0,0,32,23,pText, 0 );
	

	do
	{
		pad = padRead();
		
		if( !( pad & PAD_DOWN) )
		{
			dRotX += 5.0;
			if(dRotX >= 360.0)
				dRotX = 0.0;
		}
		else if( !( pad & PAD_UP) )
		{
			dRotX -= 5.0;
			if(dRotX < 0.0)
				dRotX = 355.0;
		}
		
		if( !( pad & PAD_RIGHT) )
		{
			dRotY += 5.0;
			if(dRotY >= 360.0)
				dRotY = 0.0;
		}
		else if( !( pad & PAD_LEFT) )
		{
			dRotY -= 5.0;
			if(dRotY < 0.0)
				dRotY = 355.0;
		}

		if( !( pad & PAD_BUTTONR) )
		{
			dRotZ += 5.0;
			if(dRotZ >= 360.0)
				dRotZ = 0.0;
		}
		else if( !( pad & PAD_BUTTONL) )
		{
			dRotZ -= 5.0;
			if(dRotZ < 0.0)
				dRotZ = 355.0;
		}

		matIdentity( rot );

		matRotateX( dRotX, rot);
		matRotateY( dRotY, rot);
		matRotateZ( dRotZ, rot);

		render( &gfxList, savageVectors, savageNames, savageBalls);

		sprDraw( &gfxList, SPRDRAW_ZORDER );		// Draw the sprites.

		//gfxList.number = 20;
		sprintf(szText,"Rotation: %03u %03u %03u",(WORD) dRotX, (WORD) dRotY, (WORD) dRotZ );
		mapPrint( 0, 18, pText, szText, &fntSystem);		

		scrWaitVSync();

	} while(1);
}

// Wait until vertical blank
void scrWaitVbl()
{
	while( !scrIsVbl() );
}
// Wait for NEXT vertical blank
void scrWaitVSync()
{
	while( scrIsVbl() );
	while( !scrIsVbl() );
}

u16 padRead()
{
	padStatus = PADREG;
	return( padStatus );
}

u16 padReadDiff()
{
	u16 diff, oldval;

	oldval = padStatus;
	diff = oldval ^ padRead();

	return( diff );
}

u16 padWaitChange()
{
	while( !padReadDiff() );

	return( padStatus );
}


// Is the screen in verticle blank?
u16 scrIsVbl()
{
	return( DISPSTAT & STAT_VBL_MASK );
}

void palCopy( u16 *pPal, int nStart, const u16 *pColours, int nCount )
{
	int i;

	for (i = nStart;i < nCount; i++)
	{
		pPal[i]=pColours[i];
	}
}

// Make a simple grid of sprites in 3D space.
/*void MakeGrid()
{
	int i, j;

	for(i = 0; i < 5; i++)
		for(j = 0; j < 5; j++ )
		{
			grid[ i + (j*5) ][0] = ( ( 16.0 * i ) - 32.0 );			// x
			grid[ i + (j*5) ][1] = ( ( 16.0 * j ) - 32.0 );			// y
			grid[ i + (j*5) ][2] = 0.0;								// z
		}
}
*/
// Place a sprite centred on a point.
// Assumes sprite is square.
// Centered about middle of screen (120, 70)
void sprPoint(GFXSPRITE *pSprite, VECTOR v, WORD size)
{
	WORD x,y,z;

	x = (WORD) v[0];
	y = (WORD) v[1];
	z = (WORD) v[2];

	
	pSprite->x = (WORD) (x - ( size >> 1 ) ) + 120;
	pSprite->y = (WORD) (y - ( size >> 1 ) ) + 78;
	pSprite->z = (WORD) ( z + 80 );
}

void render(GFXLIST *pList, const VECTOR *vectors, const WORD *names, u32 uNumber )
{
	GFXSPRITE *pSpr;
	VECTOR p;
	int i;


	pSpr = (GFXSPRITE *) pList->pHead->pNext;	// Point to first sprite
	

	// Loop for each bob
	for( i = 0; i < uNumber; i++ )
	{
		p[0] = vectors[i][0];
		p[1] = vectors[i][1];
		p[2] = vectors[i][2];

		matTransform( p, rot );		// Apply rotationg

		// Perspective project the object.
		// -------------------------------------------------------------
		// NOTE: Until the balls scale, the perspective correction code
		// is removed.

		//p[0] =  (p[0] * 160.0 ) / (p[2] + view[2]);
		//p[1] =  (p[1] * 160.0 ) / (p[2] + view[2]);

		// Translate world space to screen space

		sprPoint( pSpr, p, 16 );
		pSpr->tile = names[i];

		pSpr = (GFXSPRITE *) pSpr->pNext;
	}
}


// matIdentity( m )
// ------------------------------------------
// Sets <m> as identity matrix.

void matIdentity( MATRIX m )
{
	// Create an identity matrix
	m[0][0] = 1.0;	m[0][1] = 0.0;	m[0][2] = 0.0;	m[0][3] = 0.0;
	m[1][0] = 0.0;	m[1][1] = 1.0;	m[1][2] = 0.0;	m[1][3] = 0.0;
	m[2][0] = 0.0;	m[2][1] = 0.0;	m[2][2] = 1.0;	m[2][3] = 0.0;
	m[3][0] = 0.0;	m[3][1] = 0.0;	m[3][2] = 0.0;	m[3][3] = 1.0;
}

void matRotateX( double theta, MATRIX m )
{
	MATRIX m2;
	double sintheta, costheta;
	WORD dwTheta;

	dwTheta = (WORD) theta;

	sintheta = sinTable[dwTheta];
	costheta = cosTable[dwTheta];

	matIdentity( m2 );

	m2[1][1] = costheta;
	m2[1][2] = -sintheta;
	m2[2][1] = sintheta;
	m2[2][2] = costheta;

	matMult( m, m2 );
}

void matRotateY( double theta, MATRIX m )
{
	MATRIX m2;
	double sintheta, costheta;
	WORD dwTheta;

	dwTheta = (WORD) theta;

	sintheta = sinTable[dwTheta];
	costheta = cosTable[dwTheta];

	matIdentity( m2 );

	m2[0][0] = costheta;
	m2[0][2] = sintheta;
	m2[2][0] = -sintheta;
	m2[2][2] = costheta;

	matMult( m, m2 );
}

void matRotateZ( double theta, MATRIX m )
{
	MATRIX m2;
	double sintheta, costheta;
	WORD dwTheta;

	dwTheta = (WORD) theta;

	sintheta = sinTable[dwTheta];
	costheta = cosTable[dwTheta];

	matIdentity( m2 );

	m2[0][0] = costheta;
	m2[0][1] = -sintheta;
	m2[1][0] = sintheta;
	m2[1][1] = costheta;

	matMult( m, m2 );
}


void matTransform( VECTOR v, MATRIX m)
{
	VECTOR t;

	t[0] = v[0];
	t[1] = v[1];
	t[2] = v[2];

	v[0] = (m[0][0] * t[0]) + (m[0][1] * t[1]) + (m[0][2] * t[2]) + m[0][3];
	v[1] = (m[1][0] * t[0]) + (m[1][1] * t[1]) + (m[1][2] * t[2]) + m[1][3];
	v[2] = (m[2][0] * t[0]) + (m[2][1] * t[1]) + (m[2][2] * t[2]) + m[2][3];
}

void matMult( MATRIX d, MATRIX m )
{
	MATRIX new;

	int i,j;

	for(i=0; i < 4; i++ )
		for(j=0; j < 4; j++)
				new[j][i] = m[j][0] * d[0][i] + m[j][1] * d[1][i] + m[j][2] * d[2][i] + m[j][3] * d[3][i];

	for(i=0; i < 4; i++ )
		for(j=0; j < 4; j++)
			d[j][i] = new[j][i];
}